@echo off
setlocal enabledelayedexpansion 
cd %~dp0

pnputil /delete-driver ".\SynaAPO\AudioService.inf" /uninstall >nul 2>nul

if exist %SystemRoot%\System32\pnputil.exe (
	echo System32\pnputil.exe
    set "SystemPath=%SystemRoot%\System32"
) else if exist %SystemRoot%\Sysnative\pnputil.exe (
	echo Sysnative\pnputil.exe
    set "SystemPath=%SystemRoot%\Sysnative"
) else (
    echo ERROR: Cannot find pnputil.exe to install the driver.
    echo/
    pause
    goto :EOF
)
powershell "Get-PnpDevice -FriendlyName '*audio*'|Select-Object -Property HardwareID">[senary_temp].txt

rem withUWP, with Senary APO
type [senary_temp].txt|findstr /i "14F1039C 14F10261 1D05130D 20110255 14F10255 14F10224 14F10252"
if !errorlevel!==0 goto Install-TXAN01

rem withoutUWP, with Senary APO
type [senary_temp].txt|findstr /i "14F10256 14F10273 1E507042 14F1032B 14F10380 14F1037D 14F10247 14F10245 14F10242 14F10359 SUBSYS_14F10206 SUBSYS_14F10231 14F10215"
if !errorlevel!==0 goto Install-CA170

rem with UWP, without Senary APO
type [senary_temp].txt|findstr /i "14F10399 14F10340 14F10101"
if !errorlevel!==0 goto Install-SK2

rem For other models
echo pnputil /add-driver "chdrt-ext-common.inf" /install
%SystemPath%\pnputil.exe  /add-driver "chdrt-ext-common.inf" /install
echo pnputil /add-driver "chdrt-base.inf" /install
%SystemPath%\pnputil.exe /add-driver "chdrt-base.inf" /install
goto end

:Install-TXAN01
echo pnputil /add-driver "chdrt-ext-common.inf" /install
%SystemPath%\pnputil.exe  /add-driver "chdrt-ext-common.inf" /install
echo pnputil /add-driver "chdrt-base.inf" /install
%SystemPath%\pnputil.exe  /add-driver "chdrt-base.inf" /install
echo pnputil /add-driver ".\SynaAPO\cisstrtU-component-OEM.inf" /install
%SystemPath%\pnputil.exe  /add-driver ".\SynaAPO\cisstrtU-component-OEM.inf" /install
echo pnputil /add-driver ".\SynaAPO\AudioService.inf" /install
%SystemPath%\pnputil.exe  /add-driver ".\SynaAPO\AudioService.inf" /install
echo pnputil /add-driver ".\SenaryAPO\SenaryAPO.inf" /install
%SystemPath%\pnputil.exe  /add-driver ".\SenaryAPO\SenaryAPO.inf" /install
goto end

:Install-CA170
echo pnputil /add-driver "chdrt-ext-common.inf" /install
%SystemPath%\pnputil.exe  /add-driver "chdrt-ext-common.inf" /install
echo pnputil /add-driver "chdrt-base.inf" /install
%SystemPath%\pnputil.exe  /add-driver "chdrt-base.inf" /install
echo pnputil /add-driver ".\SenaryAPO\SenaryAPO.inf" /install
%SystemPath%\pnputil.exe  /add-driver ".\SenaryAPO\SenaryAPO.inf" /install
goto end

:Install-SK2
echo pnputil /add-driver "chdrt-ext-common.inf" /install
%SystemPath%\pnputil.exe  /add-driver "chdrt-ext-common.inf" /install
echo pnputil /add-driver "chdrt-base.inf" /install
%SystemPath%\pnputil.exe  /add-driver "chdrt-base.inf" /install
echo pnputil /add-driver ".\SynaAPO\cisstrtU-component-OEM.inf" /install
%SystemPath%\pnputil.exe  /add-driver ".\SynaAPO\cisstrtU-component-OEM.inf" /install
echo pnputil /add-driver ".\SynaAPO\AudioService.inf" /install
%SystemPath%\pnputil.exe  /add-driver ".\SynaAPO\AudioService.inf" /install
goto end

:end
for /f "tokens=*" %%i in ( 'dir C:\Windows\System32\DriverStore\FileRepository /b /a:d ^|findstr /i AudioService.inf_amd64_' ) do (
dir C:\Windows\System32\DriverStore\FileRepository\%%i /b|findstr /i SenaryAudioApp.Svc&&set sysdir=%%i
)
echo !sysdir!
REM rem search for 蓝晨 SSID
type [senary_temp].txt|findstr /i "14F10252"
if !errorlevel!==0 (sc query | findstr SenaryAudioApp||sc create SenaryAudioApp.Svc binPath="C:\Windows\System32\DriverStore\FileRepository\!sysdir!\SenaryAudioApp.Svc.exe"  start=auto
sc start SenaryAudioApp.Svc)

if exist [senary_temp].txt del [senary_temp].txt
REM restart two services
net.exe stop "audioendpointbuilder" /y
net.exe start "audioendpointbuilder"
net stop audiosrv /y
net start audiosrv


echo ===============================

